package be.ulg.hoessen.martinLeon;

import be.ulg.hoessen.martinLeon.crawler.Crawler;
import be.ulg.hoessen.martinLeon.indexeur.Index;
import be.ulg.hoessen.martinLeon.interfaceGraphique.Fenetre;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

public class IDXS {

    public static void main(String args[]) {
        if (args != null && args.length >= 1) {
            if (args[0].equals("-h") || args[0].equals("-help")) {
                System.out.println("Utilisez l'option -console pour cre\u00e9" +
                        "un nouvel index et l'enregistrer sur le disque.\n" +
                        "l'option -verbeux permet d'avoir des informations" +
                        " durant la construction ou l'agrandissement d'un " +
                        "index.");
                return;
            } else if (args[0].equals("-console")) {
                Util.modeConsole();
                if (args.length >= 2) {
                    if (args[1].equals("-verbeux")) {
                        Util.modeVerbeux();
                    }
                }
                construireEnregistrerIndex();

                return;

            } else if (args[0].equals("-verbeux")) {
                Util.modeVerbeux();
                if (args.length >= 2) {
                    if (args[1].equals("-console")) {
                        Util.modeConsole();
                        construireEnregistrerIndex();
                        return;
                    }
                }
            } else {
                System.out.println("Option " + args[0] + " non reconnue, " +
                        "utilisez l'option -h pour voir les options possibles");
            }
        }

        new Fenetre();

    }

    public static void construireEnregistrerIndex() {
        //on demande l'adresse
        String adresse = Util.lire("Quelle est l'url complet de la page de d" +
                '\u00E9' + "part ?");
        URL url = null;
        try {
            url = new URL(adresse);
        } catch (MalformedURLException e) {
            Util.erreur(e.toString());
            return;
        }
        //On demande la distance
        int distance;
        try {
            distance = Integer.parseInt(Util.lire("Quelle profondeur ?"));
        } catch (Exception e) {
            //Au cas ou l'utilisateur n'a pas rentre un chiffre
            Util.erreur(e.toString());
            return;
        }

        String domaine = Util.lire("Quel domaine ?");

        Index index = new Index();

        int nbRobots;
        Crawler crawler;
        try {
            nbRobots = Integer.parseInt(Util.lire("Combien de robots voulez vous lancer" +
                    " simultan" + '\u00e9' + "ment ?"));
            crawler = new Crawler(distance, domaine, url, index);
            if (nbRobots > 0) {
                crawler.nombreRobots(nbRobots);
            }
        } catch (Exception e) {
            //Au cas ou l'utilisateur n'a pas rentre un chiffre
            crawler = new Crawler(distance, domaine, url, index);
        }


        long debut = System.nanoTime();
        //On lance le crawler
        crawler.start();
        double temps = System.nanoTime() - debut;

        System.out.println("temps d'indexage: " + temps / 1000000000.0 + " secondes");
        //On enregistre/affiche l'index
        File fichier = Util.choisirFichier();
        try {
            index.enregistrerIndex(fichier);
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            System.exit(0);
        }
    }
}
