package be.ulg.hoessen.martinLeon.chargeurs;
import be.ulg.hoessen.martinLeon.traitement.Traiteur;

/**
 * Classe abstraite permettant de parser de l'information pour l'envoyer à un traiteur d'information
 * @author benoit, benjamin
 */
public abstract class Chargeur {
    
    /**
     * Méthode permettant de designer quelle classe traitera l'information
     * que l'on va recuperer
     * @param t le traiteur d'information
     */
    public void setTraiteur(Traiteur t){
        traiteur = t;
    }
    
    /**
     * Renvoi le traiteur d'information
     * @return le traiteur d'information
     */
    public Traiteur getTraiteur(){
        return traiteur;
    }
    
    /**
     * Methode qui permet de lancer le 'parsage' de l'information. Elle doit
     * aussi se charger de fermer le traiteur.
     */
    public abstract void charger() throws ChargeurException;
    
    private Traiteur traiteur;
}
