/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package be.ulg.hoessen.martinLeon.crawler;

import be.ulg.hoessen.martinLeon.Util;
import be.ulg.hoessen.martinLeon.indexeur.Index;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.net.URL;
import java.util.HashMap;

/**
 * Classe permettant de 
 * @author LuckyVae
 */
public class AjoutDansIndex {

    private static HashMap<String, String> mots;
    private static HashMap<String, URL> urls;

    public static void parcourirFichier(File fichier, Index index) {
        if (mots == null) {
            mots = new HashMap<String, String>();
            urls = new HashMap<String, URL>();
        }
        BufferedReader source = null;
        try {
            source = new BufferedReader(new FileReader(fichier));
            String s = source.readLine();
            String[] array;
            String key;
            URL lien;
            while (s != null && !s.equals("")) {
                array = s.split(";");
                if (array.length >= 2) {
                    if (!mots.containsKey(array[0])) {
                        mots.put(array[0], array[0]);
                    }
                    key = mots.get(array[0]);
                    if (!urls.containsKey(array[1])) {
                        urls.put(array[1], new URL(array[1]));
                    }
                    lien = urls.get(array[1]);
                    index.add(lien, key);
                } else {
                    if (Util.verbose) {
                        System.out.println("Erreur avec la ligne suivante:");
                        System.out.println(s);
                    }
                }
                s = source.readLine();
            }
        } catch (IOException ex) {
            if (Util.verbose) {
                ex.printStackTrace();
            }
        } finally {
            try {
                source.close();
            } catch (IOException ex) {
                if (Util.verbose) {
                    ex.printStackTrace();
                }
            }
        }
    }

    public static String info() {
        if (mots == null) {
            mots = new HashMap<String, String>();
            urls = new HashMap<String, URL>();
        }
        return "Nombre de mots: " + mots.size() + "\nNombre d'urls: " + urls.size();
    }
}
