package be.ulg.hoessen.martinLeon.interfaceGraphique;

import java.io.File;
import javax.swing.filechooser.FileFilter;

/**
 * Permet de filtrer les fichiers à selectionner dans un JFileChooser
 * @author benjamin, benoit
 */
public class Filtre extends FileFilter {
    
    private String description;
    private String extension;
    
    /**
     * Permet de décrire un filtre pour JFileChooser
     * @param desc la description du type de fichier
     * @param ext l'extension du type de fichier
     */
    public Filtre(String desc, String ext) {
        description = desc;
        extension = ext.toLowerCase();
    }
    
    /**
     * Permet de savoir si on accèpte ou non le fichier f dans le filtre
     * @param f le fichier dont on veut savoir si il doit être filtré ou non
     * @return true si on peut accepter le fichier
     */
    public boolean accept(File f) {
        if(f.isDirectory()){
            //renvoie vrai si f est un répertoire, sinon, on ne les voit pas
            return true;
        }
        return f.getName().toLowerCase().endsWith(extension);
    }

    /**
     * Renvoi la description du type de fichier à filtrer
     * @return la description
     */
    public String getDescription() {
        return description;
    }
    
}
