package be.ulg.hoessen.martinLeon.tests;

import be.ulg.hoessen.martinLeon.Util;
import be.ulg.hoessen.martinLeon.chargeurs.Chargeur;
import be.ulg.hoessen.martinLeon.chargeurs.ChargeurException;
import be.ulg.hoessen.martinLeon.chargeurs.ChargeurTexte;
import be.ulg.hoessen.martinLeon.traitement.Traiteur;
import be.ulg.hoessen.martinLeon.traitement.EnregistrerTexte;
import java.io.File;
import java.io.IOException;
import java.net.URL;

/**
 * Le but de cette classe est de tester ChargeurTexte ainsi que EnregistrerTexte
 *
 * @author benoit, benjamin
 */
public class TestEtape1 {
    
        
    /**
     * Méthode main pour lancer le programme
     * @param args les paramètres passés à l'exécution. Permet de savoir si on
     * lance le programe en mode console ou non.
     */
    public static void main(String args[]){
        if(args==null || args.length <1){
            Util.modeIU();
        } else{
            if(args[0].equals("-h")){
                System.out.println("Utilitaire de téléchargement de page web");
                System.out.println("Sans paramètre, le programme se lance en " +
                        "mode graphique.");
                System.out.println("Utilisez l'option -h pour voir cet écran");
                System.out.println("Utilisez l'option -console pour avoir le " +
                        "mode console");
                return;
            } else if (args[0].equals("-console")){
                Util.modeConsole();
            } else {
                System.out.println("Option "+ args[0] + " non reconnue, " +
                        "utilisez l'option -h pour voir les options possibles.");
                return;
            }
        }
        
        try {
            
            URL lien = new URL(Util.lire(
                    "Quel est l'url complet de la page html à télécharger?"));
            //Choix du fichier sur lequel on va enregistrer
            File fichier = Util.choisirFichier();
            
            //On verifie que le fichier à bien été selectionné
            if(fichier !=null){
                //On charge puis traite le fichier
                ChargeurTexte a = new ChargeurTexte();
                a.initialiserFlux(lien);
                Traiteur b = new EnregistrerTexte(fichier);
                a.setTraiteur(b);
                a.charger();
            } else {
                Util.erreur("Vous n'avez pas choisi de fichier");
            }
            
        } catch (IOException ex) {
            Util.erreur(ex.toString());
            
        } catch (ChargeurException ex) {
            Util.erreur(ex.toString());
        }
        
    }
    
    
    
}
