package be.ulg.hoessen.martinLeon.tests;

import be.ulg.hoessen.martinLeon.Util;
import be.ulg.hoessen.martinLeon.chargeurs.ChargeurException;
import be.ulg.hoessen.martinLeon.chargeurs.ChargeurTexte;
import be.ulg.hoessen.martinLeon.traitement.Afficheur;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * Permet de tester la transformation de chemins relatifs en chemins absolu
 * @author benjamin, benoit
 */
public class TestEtape2 {
    
    public static void main(String args[]) {
        if(args==null || args.length <1){
            Util.modeIU();
        } else{
            if(args[0].equals("-h")){
                System.out.println("Permet de tester le traitement d'URL" +
                        " absolue et relative");
                System.out.println("Utilisez l'option -h pour voir cet écran");
                System.out.println("Utilisez l'option -console pour avoir le " +
                        "mode console");
                return;
            } else if (args[0].equals("-console")){
                Util.modeConsole();
            } else {
                System.out.println("Option "+ args[0] + " non reconnue, " +
                        "utilisez l'option -h pour voir les options possibles");
                return;
            }
        }
        
        String absolu = Util.lire("Quel est l'adresse complète de la page à parcourir?");
        //String absolu = "http://www.luckyvae.be/";
        
                
        try {
            
            URL urlAbsolue = new URL(absolu);
            ChargeurTexte chargeur = new ChargeurTexte();
            chargeur.initialiserFlux(urlAbsolue);
            chargeur.setTraiteur(new Afficheur());
            chargeur.charger();
            
        } catch (MalformedURLException ex) {
            Util.erreur("URL mal formé\n"+ex.getMessage());
        } catch (IOException ex) {
            Util.erreur("Erreur IO\n"+ex.getMessage());
        } catch (ChargeurException ex) {
            Util.erreur("Erreur chargeur\n"+ex.getMessage());
        }
        
        
        
    }
    
}
