package be.ulg.hoessen.martinLeon.tests;

import be.ulg.hoessen.martinLeon.Util;
import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.net.MalformedURLException;
import java.net.URL;

import be.ulg.hoessen.martinLeon.crawler.Crawler;
import be.ulg.hoessen.martinLeon.indexeur.Index;

public class TestEtape3 {
    public static void main(String args[]) {
        if(args==null || args.length <1){
            Util.modeIU();
        } else{
            if(args[0].equals("-h")){
                System.out.println("Permet de se construire un petit index");
                System.out.println("Utilisez l'option -h pour voir cet "+
                        '\u00E9'+"cran");
                System.out.println("Utilisez l'option -console pour avoir le " +
                        "mode console");
                return;
            } else if (args[0].equals("-console")){
                Util.modeConsole();
            } else {
                System.out.println("Option "+ args[0] + " non reconnue, " +
                        "utilisez l'option -h pour voir les options possibles");
                return;
            }
        }
        //on demande l'adresse
        String adresse = Util.lire("Quelle est l'url complet de la page de d"+
                '\u00E9'+"part ?");
        URL url = null;
        try {
            url = new URL(adresse);
        } catch (MalformedURLException e) {
            Util.erreur(e.toString());
            return;
        }
        //On demande la distance
        int distance;
        try {
            distance = Integer.parseInt(Util.lire("Quelle profondeur ?"));
        } catch (Exception e) {
            //Au cas ou l'utilisateur n'a pas rentre un chiffre
            Util.erreur(e.toString());
            return;
        }
        
        String domaine = Util.lire("Quel domaine ?");
        
        Index index = new Index();
        
        int nbRobots;
        Crawler crawler;
        try {
            nbRobots = Integer.parseInt(Util.lire("Combien de robots voulez vous lancer" +
                    " simultan"+'\u00e9'+"ment ?"));
            crawler = new Crawler(distance, domaine, url, index);
            if(nbRobots>0)
                crawler.nombreRobots(nbRobots);
        } catch (Exception e) {
            //Au cas ou l'utilisateur n'a pas rentre un chiffre
            crawler = new Crawler(distance, domaine, url, index);
        }
        
        
        long debut = System.nanoTime();
        //On lance le crawler
        crawler.start();
        double temps = System.nanoTime()-debut;
        
        System.out.println("temps d'indexage: " + temps/1000000000.0+ " secondes");
        //On enregistre/affiche l'index
        File fichier = Util.choisirFichier();
        PrintStream sortie;
        if(fichier!=null){
            try {
                sortie = new PrintStream(fichier);
            } catch (IOException ex) {
                sortie = System.out;
            }
        } else {
            sortie = System.out;
        }
        sortie.print(index.toString());
    }
    
}