package be.ulg.hoessen.martinLeon.traitement;

import be.ulg.hoessen.martinLeon.crawler.Robot;
import be.ulg.hoessen.martinLeon.indexeur.Index;
import java.net.URL;

/**
 *
 * @author benjamin, benoit
 */
public class ConstruireIndex implements Traiteur{
    
    private boolean traiterMots;
    private Robot robot;
    private Index index;
    private URL url;
    
    /**
     * Crée une nouvelle instance de constructeur d'index
     * @param unRobot, le robot qui a créé cette instance
     * @param unIndex, l'index qui est en cours de construction
     * @param uneUrl, l'url que l'on est en train d'analyser
     */
    public ConstruireIndex(Robot unRobot, Index unIndex,
            URL uneUrl, boolean traiterMots) {
        robot = unRobot;
        index = unIndex;
        url = uneUrl;
        this.traiterMots = traiterMots;
    }
    
    public void setUrl(URL u){
        url = u;
    }
    
    public void traiter(boolean traiter){
        traiterMots = traiter;
    }
    
    public void traiterMot(String mot) {
        //System.out.println(mot);
        if (traiterMots)
            index.add(url, mot);
    }
    
    public void traiterURL(URL url) {
        robot.parcourirUrl(url);
    }
    
    public void terminer() {
    }
    
}