package be.ulg.hoessen.martinLeon.traitement;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URL;

/**
 * classe implémentant l'interface Traiteur
 * @author benoit, benjamin
 */
public class EnregistrerTexte implements Traiteur {
    
    private PrintWriter sortie;
    
    /**
     * constructeur créant un nouveau traiteur de fichier texte
     * @param fichier (le fichier à traiter)
     * @throws IOException si fichier est un dossier, si le fichier n'existe pas
     * et ne peut être créé, ou s'il ne peut être ouvert pour toute autre raison
     */
    public EnregistrerTexte(File fichier) throws IOException{
        FileWriter fWriter = new FileWriter(fichier);
        BufferedWriter tampon = new BufferedWriter(fWriter);
        // création de la sortie où va être imprimé la chaine à partir du tampon
        sortie = new PrintWriter(tampon);
    }
    
    /**
     * constructeur créant un nouveau traiteur de fichier texte
     * @param chemin (le chemin du fichier à traiter)
     * @throws IOException si fichier est un dossier, si le fichier n'existe pas
     * et ne peut être créé, ou s'il ne peut être ouvert pour toute autre raison
     */
    public EnregistrerTexte(String chemin) throws IOException {
        File fichier = new File(chemin);
        FileWriter fWriter = new FileWriter(fichier);
        BufferedWriter tampon = new BufferedWriter(fWriter);
        // création de la sortie où va être imprimé la chaine à partir du tampon
        sortie = new PrintWriter(tampon);
    }
    
    public void terminer() {
        // fermeture du fichier
        sortie.close();
    }
    
    public void traiterMot(String mot) {
        sortie.println(mot);
    }
    
    public void traiterURL(URL url) {
        sortie.println(url.toString());
    }
    
}
