package be.ulg.hoessen.martinLeon.traitement;

import java.net.URL;

/**
 * Cette interface est utilisée pour traiter informations de type chaine de caractères.
 * 
 * @author benoit, benjamin
 */
public interface Traiteur {
    
    /**
     * Méthode appelée pour traiter une chaine de caractères. 
     * @param chaine la chaine a traiter
     */
    public void traiterMot(String mot);
    
    public void traiterURL(URL url);
    
    /**
     * Méthode permettant d'indiquer que l'on a terminer d'envoyer les informations
     * à la classe implémentant cette méthode. Permet de fermer d'eventuels flux
     * qui auraient été ouverts, ou si toutes les chaines doivent être traitées
     * en une fois.
     */
    public void terminer();
        
}
